# AUTO GENERATED FILE - DO NOT EDIT

from dash.development.base_component import Component, _explicitize_args


class AntdColumn(Component):
    """An AntdColumn component.
柱状图组件AntdColumn

Keyword arguments:

- id (string; optional):
    组件唯一id.

- key (string; optional):
    对当前组件的`key`值进行更新，可实现强制重绘当前组件的效果.

- className (string; optional):
    当前组件css类名.

- style (dict; optional):
    当前组件css样式.

- data (list of dicts; required):
    必填，定义绘图所需数据.

- meta (optional):
    以字段为单位，配置图表数据元信息，来定义所涉及数据的类型和展示方式，具体见在线文档相关说明.

- xField (string; required):
    必填，图表x轴字段.

- yField (string; required):
    必填，图表y轴字段.

- seriesField (string; optional):
    图表分组字段.

- groupField (string; optional):
    `isGroup=True`时有效，用于针对堆叠分组柱状图指定分组字段.

- isStack (boolean; optional):
    `seriesField`有效时，是否渲染堆叠柱状图.

- isGroup (boolean; optional):
    `seriesField`有效时，是否渲染分组柱状图.

- isRange (boolean; optional):
    当`yField`对应数据项满足格式`[区间开始值, 区间结束值]`时，用于控制是否渲染区间柱状图.

- isPercent (boolean; optional):
    是否渲染为百分比柱状图，需配合设置`isStack=True`.

- color (dict; optional):
    控制柱体填充颜色，具体见在线文档相关说明.

    `color` is a string | list of strings | dict with keys:

    - func (string; optional):
        js函数体字符串.

- columnStyle (dict; optional):
    控制柱体填充样式，具体见在线文档相关说明.

    `columnStyle` is a dict with keys:

    - func (string; optional):
        js函数体字符串.

- slider (optional):
    配置缩略轴相关参数，具体见在线文档相关说明.

- intervalPadding (number; optional):
    分组柱状图组间间隔像素宽度.

- dodgePadding (number; optional):
    分组柱状图组内间隔像素宽度.

- minColumnWidth (number; optional):
    柱状图最小像素宽度.

- maxColumnWidth (number; optional):
    柱状图最大像素宽度.

- columnBackground (dict; optional):
    配置柱体背景相关参数，具体见在线文档相关说明.

    `columnBackground` is a dict with keys:

    - style (optional):
        柱体背景样式.

- columnWidthRatio (number; optional):
    柱体宽度比例，取值在`0`到`1`之间.

- marginRatio (number; optional):
    分组柱体间隔宽度比例，取值在`0`到`1`之间.

- scrollbar (optional):
    配置滚动条相关参数，具体见在线文档相关说明.

- conversionTag (dict; optional):
    配置转化标签相关参数，具体见在线文档相关说明.

    `conversionTag` is a dict with keys:

    - size (number; optional):
        转化率标签像素尺寸.

    - spacing (number; optional):
        转化率标签与图表元素之间的像素间距.

    - offset (number; optional):
        组件与坐标轴之间的像素距离.

    - arrow (dict; optional):
        配置转化率组件箭头样式，设置为`False`时不显示箭头.

        `arrow` is a boolean

      Or dict with keys:

        - headSize (number; optional):

            箭头像素尺寸.

    - text (dict; optional):
        配置转化率组件文本，设置为`False`时不显示文本.

        `text` is a boolean | dict with keys:

        - formatter (dict; optional):

            自定义转化率计算`javascript`函数.

            `formatter` is a dict with keys:

            - func (string; optional):

                js函数体字符串.

        - style (optional):

            转化率文本样式.

- connectedArea (dict; optional):
    配置联通对比区域相关参数，具体见在线文档相关说明.

    `connectedArea` is a dict with keys:

    - trigger (boolean | string; optional):
        触发方式，可选项有`'hover'`、`'click'`，设置为`False`时不触发. | boolean

- xAxis (optional):
    配置横坐标轴相关参数，具体见在线文档相关说明.

- yAxis (optional):
    配置纵坐标轴相关参数，具体见在线文档相关说明.

- width (number; optional):
    图表容器像素宽度.

- height (number; optional):
    图表容器像素高度.

- autoFit (boolean; optional):
    图表是否自适应所在父容器宽高，当`autoFit=True`时，`width`和`height`参数将失效  默认值：`True`.

- padding (number | list of numbers | string; optional):
    画布内边距，传入单个数值表示四周边距，也可传入格式如`[上边距，右边距，下边距，左边距]`的数组，或传入`'auto'`开启底层自动计算.

- appendPadding (number | list of numbers | string; optional):
    画布额外内边距，传入单个数值表示四周边距，也可传入格式如`[上边距，右边距，下边距，左边距]`的数组.

- renderer (a value equal to: 'canvas', 'svg'; optional):
    图表底层渲染方式，可选项有`'canvas'`和`'svg'`  默认值：`'canvas'`.

- pixelRatio (number; optional):
    `renderer='canvas'`时，控制渲染图表图片的像素比  默认值：`1`.

- locale (a value equal to: 'zh-CN', 'en-US'; default 'zh-CN'):
    图表文案语种，可选项有`'zh-CN'`、`'en-US'`  默认值：`'zh-CN'`.

- limitInPlot (boolean; optional):
    是否对超出绘图区域的几何元素进行裁剪.

- legend (optional):
    配置图例相关参数，具体见在线文档相关说明.

- label (optional):
    配置数值标签相关参数，具体见在线文档相关说明.

- tooltip (optional):
    配置信息框相关参数，具体见在线文档相关说明.

- annotations (optional):
    配置标注相关参数，具体见在线文档相关说明.

- animation (optional):
    配置动画相关参数，具体见在线文档相关说明.

- recentlyTooltipChangeRecord (dict; optional):
    事件监听属性，用于监听最近一次信息框显示事件.

    `recentlyTooltipChangeRecord` is a dict with keys:

    - timestamp (number; optional):
        事件时间戳.

    - data (list of dicts; optional):
        涉及数据信息.

- recentlyColumnClickRecord (dict; optional):
    事件监听属性，用于监听最近一次柱体点击事件.

    `recentlyColumnClickRecord` is a dict with keys:

    - timestamp (number; optional):
        事件时间戳.

    - data (dict; optional):
        涉及数据信息.

- recentlyLegendInfo (dict; optional):
    事件监听属性，用于监听最近一次图例点击事件.

    `recentlyLegendInfo` is a dict with keys:

    - triggerItemName (boolean | number | string | dict | list; optional):
        被点击图例项名称.

    - items (list of dicts; optional):
        当前各图例项信息.

- recentlySliderRange (dict; optional):
    事件监听属性，用于监听最近一次缩略轴范围变化事件.

    `recentlySliderRange` is a dict with keys:

    - timestamp (number; optional):
        事件时间戳.

    - range (list of numbers; optional):
        对应缩略轴范围.

- downloadTrigger (string; default 'download-trigger'):
    对当前组件的`downloadTrigger`值进行更新，可实现主动下载当前图表为`png`格式图片.

- theme (optional):
    配置主题相关参数，具体见在线文档相关说明.

- pattern (optional):
    配置图形填充贴图相关参数，具体见在线文档相关说明.

- interactions (optional):
    配置交互功能相关参数，具体见在线文档相关说明.

- state (optional):
    配置状态样式相关参数，具体见在线文档相关说明.

- loading_state (dict; optional)

    `loading_state` is a dict with keys:

    - is_loading (boolean; optional):
        Determines if the component is loading or not.

    - prop_name (string; optional):
        Holds which property is loading.

    - component_name (string; optional):
        Holds the name of the component that is loading."""
    _children_props = []
    _base_nodes = ['children']
    _namespace = 'feffery_antd_charts'
    _type = 'AntdColumn'
    @_explicitize_args
    def __init__(self, id=Component.UNDEFINED, key=Component.UNDEFINED, className=Component.UNDEFINED, style=Component.UNDEFINED, data=Component.REQUIRED, meta=Component.UNDEFINED, xField=Component.REQUIRED, yField=Component.REQUIRED, seriesField=Component.UNDEFINED, groupField=Component.UNDEFINED, isStack=Component.UNDEFINED, isGroup=Component.UNDEFINED, isRange=Component.UNDEFINED, isPercent=Component.UNDEFINED, color=Component.UNDEFINED, columnStyle=Component.UNDEFINED, slider=Component.UNDEFINED, intervalPadding=Component.UNDEFINED, dodgePadding=Component.UNDEFINED, minColumnWidth=Component.UNDEFINED, maxColumnWidth=Component.UNDEFINED, columnBackground=Component.UNDEFINED, columnWidthRatio=Component.UNDEFINED, marginRatio=Component.UNDEFINED, scrollbar=Component.UNDEFINED, conversionTag=Component.UNDEFINED, connectedArea=Component.UNDEFINED, xAxis=Component.UNDEFINED, yAxis=Component.UNDEFINED, width=Component.UNDEFINED, height=Component.UNDEFINED, autoFit=Component.UNDEFINED, padding=Component.UNDEFINED, appendPadding=Component.UNDEFINED, renderer=Component.UNDEFINED, pixelRatio=Component.UNDEFINED, locale=Component.UNDEFINED, limitInPlot=Component.UNDEFINED, legend=Component.UNDEFINED, label=Component.UNDEFINED, tooltip=Component.UNDEFINED, annotations=Component.UNDEFINED, animation=Component.UNDEFINED, recentlyTooltipChangeRecord=Component.UNDEFINED, recentlyColumnClickRecord=Component.UNDEFINED, recentlyLegendInfo=Component.UNDEFINED, recentlySliderRange=Component.UNDEFINED, downloadTrigger=Component.UNDEFINED, theme=Component.UNDEFINED, pattern=Component.UNDEFINED, interactions=Component.UNDEFINED, state=Component.UNDEFINED, loading_state=Component.UNDEFINED, **kwargs):
        self._prop_names = ['id', 'key', 'className', 'style', 'data', 'meta', 'xField', 'yField', 'seriesField', 'groupField', 'isStack', 'isGroup', 'isRange', 'isPercent', 'color', 'columnStyle', 'slider', 'intervalPadding', 'dodgePadding', 'minColumnWidth', 'maxColumnWidth', 'columnBackground', 'columnWidthRatio', 'marginRatio', 'scrollbar', 'conversionTag', 'connectedArea', 'xAxis', 'yAxis', 'width', 'height', 'autoFit', 'padding', 'appendPadding', 'renderer', 'pixelRatio', 'locale', 'limitInPlot', 'legend', 'label', 'tooltip', 'annotations', 'animation', 'recentlyTooltipChangeRecord', 'recentlyColumnClickRecord', 'recentlyLegendInfo', 'recentlySliderRange', 'downloadTrigger', 'theme', 'pattern', 'interactions', 'state', 'loading_state']
        self._valid_wildcard_attributes =            []
        self.available_properties = ['id', 'key', 'className', 'style', 'data', 'meta', 'xField', 'yField', 'seriesField', 'groupField', 'isStack', 'isGroup', 'isRange', 'isPercent', 'color', 'columnStyle', 'slider', 'intervalPadding', 'dodgePadding', 'minColumnWidth', 'maxColumnWidth', 'columnBackground', 'columnWidthRatio', 'marginRatio', 'scrollbar', 'conversionTag', 'connectedArea', 'xAxis', 'yAxis', 'width', 'height', 'autoFit', 'padding', 'appendPadding', 'renderer', 'pixelRatio', 'locale', 'limitInPlot', 'legend', 'label', 'tooltip', 'annotations', 'animation', 'recentlyTooltipChangeRecord', 'recentlyColumnClickRecord', 'recentlyLegendInfo', 'recentlySliderRange', 'downloadTrigger', 'theme', 'pattern', 'interactions', 'state', 'loading_state']
        self.available_wildcard_properties =            []
        _explicit_args = kwargs.pop('_explicit_args')
        _locals = locals()
        _locals.update(kwargs)  # For wildcard attrs and excess named props
        args = {k: _locals[k] for k in _explicit_args}

        for k in ['data', 'xField', 'yField']:
            if k not in args:
                raise TypeError(
                    'Required argument `' + k + '` was not specified.')

        super(AntdColumn, self).__init__(**args)
